#decode.py
f = open("encoded.txt")     #打开并读取密文内容至s
s = f.read().lower()        
f.close()

stats = {}                  #对密文中的字母出现次数进行统计
for c in s:
    if c.isalpha():
        stats[c.lower()] = stats.get(c.lower(),0) + 1

stats = list(stats.items()) #将字典转换为列表，对字母按出现次数降序排序
stats.sort(key=lambda x:x[1],reverse=True)
stats = "".join([x[0] for x in stats])
print("密文统计的按频次降序排列的英文字母:", stats)

codes = "etansoirhldygmcubwfkvpjzxq"
print("语料统计的按频次降序排序的英文字母:",codes)

r = ""                      #进行解密，明文存于r
for c in s:
    if c.isalpha():
        r += codes[stats.index(c)]
    else:
        r += c

f = open("decoded.txt","wt")  #将明文r写入文件
f.write(r)
f.close()
print("解密完成: decoded.txt")